"""This file provides autocompletions for the ZOS-API and was automatically generated.
It should not be edited manually.
"""

from __future__ import annotations

from typing import Iterable, overload

from zospy.api._ZOSAPI.Analysis import HuygensShowAsTypes, SampleSizes
from zospy.api._ZOSAPI.Analysis.Settings import (
    IAS_,
    HuygensPsfTypes,
    PsfSpread,
    PsfTypes,
    Rotations,
)

__all__ = (
    "FftPsfType",
    "IAS_FftPsf",
    "IAS_FftPsfCrossSection",
    "IAS_FftPsfLineEdgeSpread",
    "IAS_HuygensPsf",
    "IAS_HuygensPsfCrossSection",
    "PsfRotation",
    "PsfSampling",
)

class FftPsfType:
    Linear = 0
    Log = 1
    Phase = 2
    Real = 3
    Imaginary = 4

class IAS_FftPsf(IAS_):
    @property
    def Field(self) -> IAS_Field: ...
    @property
    def Surface(self) -> IAS_Surface: ...
    @property
    def Wavelength(self) -> IAS_Wavelength: ...
    @property
    def SampleSize(self) -> PsfSampling: ...
    @SampleSize.setter
    def SampleSize(self, value: PsfSampling) -> None: ...
    @property
    def OutputSize(self) -> PsfSampling: ...
    @OutputSize.setter
    def OutputSize(self, value: PsfSampling) -> None: ...
    @property
    def Rotation(self) -> PsfRotation: ...
    @Rotation.setter
    def Rotation(self, value: PsfRotation) -> None: ...
    @property
    def ImageDelta(self) -> float: ...
    @ImageDelta.setter
    def ImageDelta(self, value: float) -> None: ...
    @property
    def UsePolarization(self) -> bool: ...
    @UsePolarization.setter
    def UsePolarization(self, value: bool) -> None: ...
    @property
    def Type(self) -> FftPsfType: ...
    @Type.setter
    def Type(self, value: FftPsfType) -> None: ...
    @property
    def Normalize(self) -> bool: ...
    @Normalize.setter
    def Normalize(self, value: bool) -> None: ...

class IAS_FftPsfCrossSection(IAS_):
    @property
    def Field(self) -> IAS_Field: ...
    @property
    def Wavelength(self) -> IAS_Wavelength: ...
    @property
    def SampleSize(self) -> SampleSizes: ...
    @SampleSize.setter
    def SampleSize(self, value: SampleSizes) -> None: ...
    @property
    def Type(self) -> PsfTypes: ...
    @Type.setter
    def Type(self, value: PsfTypes) -> None: ...
    @property
    def UsePolarization(self) -> bool: ...
    @UsePolarization.setter
    def UsePolarization(self, value: bool) -> None: ...
    @property
    def Normalize(self) -> bool: ...
    @Normalize.setter
    def Normalize(self, value: bool) -> None: ...
    @property
    def PlotScale(self) -> float: ...
    @PlotScale.setter
    def PlotScale(self, value: float) -> None: ...
    @property
    def RowCol(self) -> int: ...
    @RowCol.setter
    def RowCol(self, value: int) -> None: ...

class IAS_FftPsfLineEdgeSpread(IAS_):
    @property
    def Field(self) -> IAS_Field: ...
    @property
    def Wavelength(self) -> IAS_Wavelength: ...
    @property
    def SampleSize(self) -> SampleSizes: ...
    @SampleSize.setter
    def SampleSize(self, value: SampleSizes) -> None: ...
    @property
    def Spread(self) -> PsfSpread: ...
    @Spread.setter
    def Spread(self, value: PsfSpread) -> None: ...
    @property
    def Type(self) -> PsfTypes: ...
    @Type.setter
    def Type(self, value: PsfTypes) -> None: ...
    @property
    def UseCoherentPSF(self) -> bool: ...
    @UseCoherentPSF.setter
    def UseCoherentPSF(self, value: bool) -> None: ...
    @property
    def UsePolarization(self) -> bool: ...
    @UsePolarization.setter
    def UsePolarization(self, value: bool) -> None: ...
    @property
    def PlotScale(self) -> float: ...
    @PlotScale.setter
    def PlotScale(self, value: float) -> None: ...

class IAS_HuygensPsf(IAS_):
    @property
    def Field(self) -> IAS_Field: ...
    @property
    def Wavelength(self) -> IAS_Wavelength: ...
    @property
    def PupilSampleSize(self) -> SampleSizes: ...
    @PupilSampleSize.setter
    def PupilSampleSize(self, value: SampleSizes) -> None: ...
    @property
    def ImageSampleSize(self) -> SampleSizes: ...
    @ImageSampleSize.setter
    def ImageSampleSize(self, value: SampleSizes) -> None: ...
    @property
    def Type(self) -> HuygensPsfTypes: ...
    @Type.setter
    def Type(self, value: HuygensPsfTypes) -> None: ...
    @property
    def ShowAsType(self) -> HuygensShowAsTypes: ...
    @ShowAsType.setter
    def ShowAsType(self, value: HuygensShowAsTypes) -> None: ...
    @property
    def Rotation(self) -> Rotations: ...
    @Rotation.setter
    def Rotation(self, value: Rotations) -> None: ...
    @property
    def Normalize(self) -> bool: ...
    @Normalize.setter
    def Normalize(self, value: bool) -> None: ...
    @property
    def UseCentroid(self) -> bool: ...
    @UseCentroid.setter
    def UseCentroid(self, value: bool) -> None: ...
    @property
    def UsePolarization(self) -> bool: ...
    @UsePolarization.setter
    def UsePolarization(self, value: bool) -> None: ...
    @property
    def ImageDelta(self) -> float: ...
    @ImageDelta.setter
    def ImageDelta(self, value: float) -> None: ...
    @property
    def Configuration(self) -> int: ...
    @Configuration.setter
    def Configuration(self, value: int) -> None: ...

class IAS_HuygensPsfCrossSection(IAS_):
    @property
    def Field(self) -> IAS_Field: ...
    @property
    def Wavelength(self) -> IAS_Wavelength: ...
    @property
    def PupilSampleSize(self) -> SampleSizes: ...
    @PupilSampleSize.setter
    def PupilSampleSize(self, value: SampleSizes) -> None: ...
    @property
    def ImageSampleSize(self) -> SampleSizes: ...
    @ImageSampleSize.setter
    def ImageSampleSize(self, value: SampleSizes) -> None: ...
    @property
    def Type(self) -> PsfTypes: ...
    @Type.setter
    def Type(self, value: PsfTypes) -> None: ...
    @property
    def Normalize(self) -> bool: ...
    @Normalize.setter
    def Normalize(self, value: bool) -> None: ...
    @property
    def UseCentroid(self) -> bool: ...
    @UseCentroid.setter
    def UseCentroid(self, value: bool) -> None: ...
    @property
    def UsePolarization(self) -> bool: ...
    @UsePolarization.setter
    def UsePolarization(self, value: bool) -> None: ...
    @property
    def ImageDelta(self) -> float: ...
    @ImageDelta.setter
    def ImageDelta(self, value: float) -> None: ...
    @property
    def Configuration(self) -> int: ...
    @Configuration.setter
    def Configuration(self, value: int) -> None: ...
    @property
    def RowCol(self) -> int: ...
    @RowCol.setter
    def RowCol(self, value: int) -> None: ...

class PsfRotation:
    CW0 = 0
    CW90 = 1
    CW180 = 2
    CW270 = 3

class PsfSampling:
    PsfS_32x32 = 1
    PsfS_64x64 = 2
    PsfS_128x128 = 3
    PsfS_256x256 = 4
    PsfS_512x512 = 5
    PsfS_1024x1024 = 6
    PsfS_2048x2048 = 7
    PsfS_4096x4096 = 8
    PsfS_8192x8192 = 9
    PsfS_16384x16384 = 10
