"""This file provides autocompletions for the ZOS-API and was automatically generated.
It should not be edited manually.
"""

from __future__ import annotations

from typing import Iterable, overload

__all__ = (
    "DateTimeType",
    "EncodingType",
    "IPreferencesEditor",
    "IPreferencesFolders",
    "IPreferencesGeneral",
    "LanguageType",
    "ShowLineAsType",
)

class DateTimeType:
    # None = 0
    Date = 1
    DateTime = 2

class EncodingType:
    ANSI = 0
    Unicode = 1

class IPreferencesEditor:
    @property
    def Decimals(self) -> int: ...
    @Decimals.setter
    def Decimals(self, value: int) -> None: ...
    @property
    def ExponentialAbove(self) -> float: ...
    @ExponentialAbove.setter
    def ExponentialAbove(self, value: float) -> None: ...
    @property
    def ExponentialBelow(self) -> float: ...
    @ExponentialBelow.setter
    def ExponentialBelow(self, value: float) -> None: ...

class IPreferencesFolders:
    @property
    def ProgramDirectory(self) -> str: ...
    @property
    def DataDirectory(self) -> str: ...
    @property
    def LensDirectory(self) -> str: ...
    @LensDirectory.setter
    def LensDirectory(self, value: str) -> None: ...
    @property
    def ObjectsDirectory(self) -> str: ...
    @ObjectsDirectory.setter
    def ObjectsDirectory(self, value: str) -> None: ...
    @property
    def ZplDirectory(self) -> str: ...
    @ZplDirectory.setter
    def ZplDirectory(self, value: str) -> None: ...
    @property
    def GlassDirectory(self) -> str: ...
    @GlassDirectory.setter
    def GlassDirectory(self, value: str) -> None: ...
    @property
    def CoatingDirectory(self) -> str: ...
    @CoatingDirectory.setter
    def CoatingDirectory(self, value: str) -> None: ...
    @property
    def PopDirectory(self) -> str: ...
    @PopDirectory.setter
    def PopDirectory(self, value: str) -> None: ...
    @property
    def ImagesDirectory(self) -> str: ...
    @ImagesDirectory.setter
    def ImagesDirectory(self, value: str) -> None: ...
    @property
    def SolidWorksDirectory(self) -> str: ...
    @SolidWorksDirectory.setter
    def SolidWorksDirectory(self, value: str) -> None: ...
    @property
    def InventorDirectory(self) -> str: ...
    @InventorDirectory.setter
    def InventorDirectory(self, value: str) -> None: ...
    @property
    def CreoDirectory(self) -> str: ...
    @CreoDirectory.setter
    def CreoDirectory(self, value: str) -> None: ...
    @property
    def MatlabDirectory(self) -> str: ...
    @MatlabDirectory.setter
    def MatlabDirectory(self, value: str) -> None: ...
    @property
    def ScatterDirectory(self) -> str: ...
    @ScatterDirectory.setter
    def ScatterDirectory(self, value: str) -> None: ...
    @property
    def UndoDirectory(self) -> str: ...
    @UndoDirectory.setter
    def UndoDirectory(self, value: str) -> None: ...
    @property
    def CreoInstallDirectory(self) -> str: ...
    @CreoInstallDirectory.setter
    def CreoInstallDirectory(self, value: str) -> None: ...
    def ChangeDataDirectory(self, newDirectory: str) -> None: ...

class IPreferencesGeneral:
    @property
    def DateTimeFormat(self) -> DateTimeType: ...
    @DateTimeFormat.setter
    def DateTimeFormat(self, value: DateTimeType) -> None: ...
    @property
    def Language(self) -> LanguageType: ...
    @Language.setter
    def Language(self, value: LanguageType) -> None: ...
    @property
    def ZMXFileEncoding(self) -> EncodingType: ...
    @ZMXFileEncoding.setter
    def ZMXFileEncoding(self, value: EncodingType) -> None: ...
    @property
    def TXTFileEncoding(self) -> EncodingType: ...
    @TXTFileEncoding.setter
    def TXTFileEncoding(self, value: EncodingType) -> None: ...
    @property
    def UseSessionFiles(self) -> bool: ...
    @UseSessionFiles.setter
    def UseSessionFiles(self, value: bool) -> None: ...
    @property
    def IncludeCalculatedDataInSession(self) -> bool: ...
    @IncludeCalculatedDataInSession.setter
    def IncludeCalculatedDataInSession(self, value: bool) -> None: ...
    @property
    def IncludeToleranceDataInSession(self) -> bool: ...
    @IncludeToleranceDataInSession.setter
    def IncludeToleranceDataInSession(self, value: bool) -> None: ...
    @property
    def UpdateMostRecentlyUsedList(self) -> bool: ...
    @UpdateMostRecentlyUsedList.setter
    def UpdateMostRecentlyUsedList(self, value: bool) -> None: ...
    @property
    def UserPreferences(self) -> str: ...
    @UserPreferences.setter
    def UserPreferences(self, value: str) -> None: ...
    def GetIsGPUEnabled(self) -> bool: ...
    def GetUseParasolid(self) -> bool: ...
    def SetIsGPUEnabled(self, isEnabled: bool) -> bool: ...
    def SetUseParasolid(self, use: bool) -> bool: ...

class LanguageType:
    Chinese = 0
    English = 1
    Japanese = 4

class ShowLineAsType:
    TextAbove = 0
    FileName = 1
    ConfigurationNumber = 2
